#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>

// evaluates to 1 if leap year
int leap(int year)
{
  return(!(year%400) || (!(year%4) && (year%100)));
}

// return Day Of Year 1 to 366
int doy(int month, int day, int year)
{
  int n = ((unsigned)month*3057-3007)/100 + day;

  if (month > 2) n -= 2-leap(year);

  return(n);
}

// return days in specified month
int days(int month, int year)
{
  int n = ((unsigned)(month+1)*3057-3007)/100 -
          ((unsigned)month    *3057-3007)/100;

  if (month == 2) n -= 2-leap(year);

  return(n);
}

// return Day Of Week of specified day, 0 = Sunday, 6 = Saturday
int dow(int month, int day, int year)
{
  if (month < 3)                // if Jan or Feb
  {
    month += 12 ;               // make them month 13 and 14 of
    year -= 1 ;                 // the previous year!
  }
  return((day + ((26 * (month + 1)) / 10)
              + ((125L * year) / 100)
              - (year/100) + (year/400) -1) % 7) ;
}

void main(void)
{
  int month,day,year,n,x,l;
  struct date d;
  char far *cmd = MK_FP(_psp,0x80);
  char buffer[128];

  char months[][20] = {"January","February","March","April",
                       "May","June","July","August",
                       "September","October","November","December"};
  getdate(&d);
  month = d.da_mon;
  day = d.da_day;
  year = d.da_year;

  if (*cmd)
  {
    cmd[*cmd+1]=0;
    _fstrcpy(buffer,cmd+1);
    month = 0;
    day = 0;
    year = 0;
    sscanf(buffer,"%d%*[ /]%d",&month,&year);

    if ((month < 1) || (month > 12))
    {
      puts("Usage: CAL [month / year]");
      return;
    }

    if (year < 100) year+=2000;
  }

  l = days(month,year);
  printf("\n%s %d\n"
         "Su Mo Tu We Th Fr Sa",months[month-1],year);

  for(x = 1-dow(month,1,year), n = 0; x <= l; x++, n++)
  {
    if (!(n%7)) putchar('\n');
    if (x < 1) printf("   ");
    else if (x == day) printf("%2d",x);
    else printf("%2d ",x);
  }
  putchar('\n');
}





