typedef struct {
  void **head, **tail;
  int count;
} semaphore;

// this list of tasks waiting for the CPU
extern const semaphore readylist;

// initialize a semaphore (to all zero's)
void seminit(semaphore *s);

// signal a semaphore
void _signal(semaphore *s);
#define signal(s) _signal(&s)

// Start a task. This initializes the task's stack frame.
void _start(void (*task)(void), char *stack, int size);
#define start(t) _start(t,t##_stack,sizeof(t##_stack))

// Wait for a semaphore
void _wait(semaphore *s);

// suspend the current task if any other tasks are waiting to run
#define pause() {if (readylist.head) _wait(&readylist);}

// wait for a semaphore to be signaled.
#define wait(s) { if (!s.count) _wait(&s); else { s.count--; pause(); }}


