#include <stdio.h>

// random number generator

char table[MAX], a, b;

void rndinit(void)
{
  int x;

  // in reality, you would initialize this to your shared secret
  // a and b can be any number less than MAX
  a = b = 0;

  // each table entry must be less than MAX
  // each value must be used only once
  // thus: 1, 7, 2, 5, 3, 4, 0, 6, etc.
  for (x=0; x < MAX; x++) table[x] = x;
}

// random number generator, returns 0 thru MAX
int rnd(void)
{
  char ta, tb;

  a=(a+1)%MAX;
  ta = table[a];
  b = (b+ta)%MAX;
  tb = table[b];
  table[a]=tb;
  table[b]=ta;
  return(table[(ta+tb)%MAX]);
}


; PIC RNG, returns 0-15
rndinit    movlw 0      ; change to anything, 0-15
           movwf rnda
           movlw 0      ; change to anything, 0-15
           movwf rndb
           movlw 7
           movwf table
           movlw 2
           movwf table+1
           movlw 4
           movwf table+2
           movlw 9
           movwf table+3
           movlw 15
           movwf table+4
           movlw 12
           movwf table+5
           movlw 0
           movwf table+6
           movlw 1
           movwf table+7
           movlw 13
           movwf table+8
           movlw 5
           movwf table+9
           movlw 6
           movwf table+10
           movlw 11
           movwf table+11
           movlw 3
           movwf table+12
           movlw 10
           movwf table+13
           movlw 8
           movwf table+14
           movlw 14
           movwf table+15
           return

rnd        movf a,w                     ; get current a
           addlw 1                      ; inc
           andlw 15                     ; keep in range
           movf a,f                     ; save
           addwf b,w                    ; add current b
           andlw 15                     ; keep in range
           movf b,f                     ; save new b
           addlw table                  ; index table[b]
           movwf IND
           movf INP,w
           movwf tb                     ; save as tb
           movf a,w                     ; get a
           movwf IND                    ; index table[a]
           addlw table
           movf INP,w
           movwf ta                     ; save as ta
           movf tb,w                    ; get tb back
           movwf INP                    ; store to table[a]
           movf b,w                     ; now index table[b]
           addlw table
           movwf IND
           movf ta,w                    ; get ta
           movwf INP                    ; store in table[b]
           addwf tb                     ; now add ta+tb
           andlw 15                     ; keep in range
           addlw table                  ; index table[ta+tb]
           movwf IND                    ; get data there
           movf INP,w
           return                       ; and return
