// crypto routines

// Our max key length is 128 bits, we can encode ln95/ln2=6.569 bits per
// char, so our longest key length 128/6.569 = 19.48 = 20 + termination
typedef char KEY[21];

// comment out unused features
#define ENCRYPT
#define DECRYPT
#define KEYGEN

#ifdef ENCRYPT
// encrypt message in place, with EKEY,
void encrypt(KEY E, KEY message);
#endif

#ifdef DECRYPT
// decrypt message in place
void decrypt(KEY D, KEY E, KEY message);
#endif

#ifdef KEYGEN
// Generate public (E) and private (D) keys
// Each key should be initialized with random chars ' ' to '~',
// attempts to limit key length to specified number of bits,
// returns actual bit length of E.
int keygen(KEY D, KEY E, int bits);
#endif
