struct
{
  char name[5];   // timezone name
  int offset;     // Offset from UCT * .1 hours
  struct
  {
    int month;    // DST start month, 1=January, 0=none
    int week;     // DST start week, 1 = first, 2 = second, 0 = last
    int dow;      // DST start day, 1 = Sunday, 7 = Saturday
    int time;     // DST start time in .1 hours
  } start;
  struct
  {
    int month;    // DST end month
    int week;     // DST end week, 0 = last
    int dow;      // DST end day of week
    int time;     // DST end time in .1 hours
  } end;
} timez[] =
// Example: "PST", -80, 4, 1, 1, 20, 10, 0, 1, 20}
// "PST" has a UCT offset of -8.0 hours (-80).
// An additional hour of offset is added during DST:
//   from April (4), on the first (1) Sunday (1) at 2:00 a.m (20)
//   until October (10), on the last (0) Sunday (1) at 2:00 a.m (20)

{"NST",  120, 4, 1, 1, 20, 10, 0, 1, 20},       // New Zealand Standard Time
{"SST",  110, 0},                               // Solomon Standard Time
{"AET",  100, 4, 1, 1, 20, 10, 0, 1, 20},       // Australia Eastern Time
{"ACT",   95, 4, 1, 1, 20, 10, 0, 1, 20},       // Australia Central Time
{"KST",   90, 0},                               // Korea Standard Time
{"JST",   90, 0},                               // Japan Standard Time
{"CTT",   80, 0},                               // China Taiwan Time
{"VST",   70, 0},                               // Vietnam Standard Time
{"BST",   60, 0},                               // Bangladesh Standard Time
{"IST",   55, 0},                               // India Standard Time
{"PLT",   50, 0},                               // Pakistan Lahore Time
{"NET",   40, 0},                               // Near East Time
{"MET",   35, 0},                               // Middle East Time
{"EAT",   30, 0},                               // Eastern African Time
{"ART",   20, 5, 1, 1, 20, 10, 1, 1, 20},       // (Arabic) Egypt Standard Time
{"EET",   20, 3, 0, 1, 20,  9, 0, 1, 20},       // Eastern European Time
{"ECT",   10, 3, 0, 1, 20,  9, 0, 1, 20},       // European Central Time
{"GMT",    0, 3, 0, 1, 20, 10, 4, 1, 20},       // Greenwich Mean Time
{"CAT",  -10, 0},                               // Central African Time
{"BET",  -30, 4, 1, 1, 20, 10, 0, 1, 20},       // Brazil Eastern Time
{"AGT",  -30, 0},                               // Argentina Standard Time
{"CNT",  -35, 4, 1, 1, 20, 10, 0, 1, 20},       // Canada Newfoundland Time
{"PRT",  -40, 0},                               // Puerto Rico and US Virgin Islands Time
{"EST",  -50, 4, 1, 1, 20, 10, 0, 1, 20},       // Eastern Standard Time
{"IET",  -50, 0},                               // Indiana Eastern Standard Time
{"CST",  -60, 4, 1, 1, 20, 10, 0, 1, 20},       // Central Standard Time
{"MST",  -70, 4, 1, 1, 20, 10, 0, 1, 20},       // Mountain Standard Time
{"PNT",  -70, 0},                               // Phoenix Standard Time
{"PST",  -80, 4, 1, 1, 20, 10, 0, 1, 20},       // Pacific Standard Time
{"YST",  -90, 4, 1, 1, 20, 10, 0, 1, 20},       // Yukon (Alaska) Standard Time
{"HST", -100, 0},                               // Hawaii Standard Time
{"MIT", -110, 0},                               // Midway Islands Time
{""}};


