# compile script, insert into database
# used by dbman and dbpull 
package dbCGI::compile;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(compile);

use warnings;
use strict;
use CGI qw(param);
use File::Temp 'tempdir';

# given device_id and source 
# compile script for device_id and update database ($::DB)
# return undef if success, else (error code,text) 
sub compile($$)
{
  my ($device_id, $source)=@_;
  my ($deviceid, $cpeid, $cpe_id)=::getdevice $device_id;
  my $compiler = "/crux/dbug/lsl/$cpeid";
  -x $compiler or return(503,"no compiler $compiler"); 

  my $temp = tempdir(CLEANUP=>1); 
  chdir $temp or return(503,"chdir $temp: $!");
 
  # the compiler expects a file name...
  open F,">script.txt" or return(503,"open script.txt: $!"); print F $source or return(503,"write $temp/script.txt: $!"); close F;
  my $result = `$compiler script.txt 2>&1`; 	# compile in place, capture output messages
  $? and return(503,$result);				
	 
  # compile was successful
  my %file;
  opendir D,'.'; my @files=readdir D; closedir D;  
  for (@files)  
  {
    /\.\d\.(\d+)$/ && $1 >= 250 && $1 <= 255 or next; # something.n.255
    local $/;
    open F, $_ or return(503,"open $_: $?");
    $file{"obj$1"}=<F>;
    close F;
  }

  exists $file{obj255} or return(503,"missing obj255");
  my $scriptid = (split /\n/,$file{obj255},2)[0] or return(503,"broken scriptid"); # peel off first string for scriptid
  $::DB->do("update device set source=?, obj250=?, obj251=?, obj252=?, obj253=?, obj254=?, obj255=?, scriptid=? where id=?", undef,
             $source, $file{obj250}, $file{obj251}, $file{obj252}, $file{obj253}, $file{obj254}, $file{obj255}, $scriptid, $device_id)
    or return(503,"update failed");

  (200, "OK"); # success
}

1;
