#!/usr/bin/perl

use CGI 'param';
use DBI;
use warnings;
use strict;

# output html page
sub html($@)
{
  my $title = shift;
  my $html = join '',@_;

  print "Content-type: text/html\n\n<html>
         <head><title>$title</title>
         </head>
         <body>
         $html  
         </body></html>";
  exit;
}

$SIG{__DIE__}= sub { chomp(my @s = @_); html "Sorry","An error has occurred: @s." };
$SIG{__WARN__}=sub { warn "@{[scalar localtime]}:$ENV{QUERY_STRING}]:@_" }; # add timestamp because apache doesn't

# lookup specified home page, or the 'default' page
my $name=param('key')||'default';

my $DB;

for (reverse 0..10) # try 10 times
{
  $DB = DBI->connect('DBI:mysql:news:db','news',undef,{RaiseError => 1, AutoCommit=>1}) and last;
  $_ or die "can't connect to database\n";
  sleep 1;
}

my ($title, $page) = $DB->selectrow_array('select title, page from homepage where name = ?',undef,$name);
defined $page or die "no page found for key '$name', please contact Landel Customer Support\n";
html $title, $page; 
