#!/usr/bin/perl


print <<EOT;
Content-type: text/html

<html>
<head><title>Headline News</title>
</head><body>
<tt>
We're very sorry, due to circumstances outside of our control 
we are currently unable to supply headline news articles.
We hope to have a replacement source very soon. We apologize for the incovenience and thank you for your patience.<p>
== Mailbug Operations Team
</body>
EOT


__END__

use CGI;
use URI;
use LWP::Simple;
use warnings;
use strict;
use DBI;
use MIME::Lite;

# get html param or die
sub need($)
{
  my $r = CGI::param($_[0]) or die "missing param '$_[0]'\n";
  $r;
} 

# output html page
sub html($@)
{
  my $title = shift;
  my $html = join '',@_;

  print "Content-type: text/html\n\n<html>
         <head><title>$title</title>
         </head>
         <body>
         $html  
         </body></html>";
  exit;
}

$SIG{__DIE__}= sub { chomp(my @s = @_); html "Sorry","An error has occurred: @s." };
$SIG{__WARN__}=sub { warn "@{[scalar localtime]}:$ENV{QUERY_STRING}]:@_" }; # add timestamp because apache doesn't

# news reader

# mysql> desc news;
# +----------+------------------+------+-----+---------+----------------+
# | Field    | Type             | Null | Key | Default | Extra          |
# +----------+------------------+------+-----+---------+----------------+
# | id       | bigint(20)       |      | PRI | NULL    | auto_increment |
# | sendid   | tinytext         |      | MUL |         |                |
# | headline | tinytext         |      |     |         |                |
# | text     | text             |      |     |         |                |
# | date     | int(10) unsigned |      |     | 0       |                |
# | grp      | tinytext         |      |     |         |                |
# +----------+------------------+------+-----+---------+----------------+
# 6 rows in set (0.01 sec)

my %states = (
'top' => sub 
{
  my $DB = DBI->connect('DBI:mysql:news:db','news',undef,{RaiseError => 1, AutoCommit=>1}) or die "can't connect to news database, please try again later\n";
  # main news index
  my $html;
  for (@{$DB->selectall_arrayref('select distinct grp from news order by grp asc')})
  {
     ($_->[1] = $_->[0]) =~ tr/ /_/;
     $html .=  "<form>
                <input type=hidden name=state value=listnews>
                <input type=hidden name=grp value='$_->[0]'>
                &lt;--<input type=submit name=cooked value='$_->[1]' bind=left></form>";
  }
  html "Headline News -- Select a Category",$html;
},

'listnews'=>sub
{
  my $DB = DBI->connect('DBI:mysql:news:db','news',undef,{RaiseError => 1, AutoCommit=>1}) or die "can't connect to news database, please try again later\n";
  my $html;
  my $grp = need 'grp';
  my $cooked = need 'cooked';

  # clarinet sometimes gives duplicate articles, so we 'group by headline'
  for my $item (@{$DB->selectall_arrayref('select sendid, headline from news where grp=? group by headline order by date desc limit 10',undef,$grp)})
  {
    # add the link 
    $html .= "<form>
              <input type=hidden name=state value=readnews>
              <input type=hidden name=cooked value='$cooked'>
              <input type=hidden name=sendid value='$item->[0]'>
               &lt;--<input type=submit value='".(CGI::escapeHTML(substr($item->[1],0,75)))."' bind=left></form>";
  }
  html "$cooked -- Select a Headline",$html;
},  

'readnews'=>sub
{
  my $DB = DBI->connect('DBI:mysql:news:db','news',undef,{RaiseError => 1, AutoCommit=>1}) or die "can't connect to news database, please try again later\n";
  my $cooked=need 'cooked';
  my $sendid=need 'sendid';

  my ($h, $t) = $DB->selectrow_array('select headline, text from news where sendid=?',undef,$sendid);
  $t or die "article '$sendid' not found\n";
  html $cooked,CGI::escapeHTML($h),"<p>$t<p>
                                    <form>
                                    <input type=hidden name=state value=mailto>
                                    <input type=hidden name=cooked value='$cooked'>
                                    <input type=hidden name=sendid value='$sendid'>
                                    &lt;--<input type=submit value='Mail this article to yourself' bind=left></form>";
                                      
},

'mailto'=>sub
{
  my $DB = DBI->connect('DBI:mysql:news:db','news',undef,{RaiseError => 1, AutoCommit=>1}) or die "can't connect to news database, please try again later\n";
  my $cooked=need 'cooked';
  my $sendid=need 'sendid';
  my $address=CGI::cookie('address') or die "cannot determine your email address, please contact Mailbug Customer Support\n";

  my ($head, $text) = $DB->selectrow_array('select headline, text from news where sendid=?',undef,$sendid);
  MIME::Lite->send('sendmail', '/usr/sbin/sendmail -t -odd -oem -fdo_not_reply@mailbug.net');
  MIME::Lite->new(To      => $address,
                  Subject => $head,
                  From    => 'MailBug Info - News by Email <do_not_reply@mailbug.net>',
                  Type    => 'text/html',
                  Data    => "<html><body>$text</body></html>")->send();
  html $cooked,"The article has been sent to '$address'.";
},
                
);


my $state = (CGI::param 'state') || 'top'; 
exists $states{$state} and $states{$state}->(); 
die "invalid cgi state '$state'";


