#!/usr/bin/perl

use CGI;
use URI;
use LWP::Simple;
use Finance::Quote;
use warnings;
use strict;
use DBI;

# get html param or die
sub need($)
{
  my $r = CGI::param($_[0]) or die "missing param '$_[0]'\n";
  $r;
} 

# output html page
sub html($@)
{
  my $title = shift;
  my $html = join '',@_;

  print "Content-type: text/html\n\n<html>
         <head><title>$title</title>
         </head>
         <body>
         $html  
         </body></html>";
  exit;
}

$SIG{__DIE__}= sub { chomp(my @s = @_); html "Sorry","An error has occurred: @s." };
$SIG{__WARN__}=sub { warn "@{[scalar localtime]}:$ENV{QUERY_STRING}]:@_" }; # add timestamp because apache doesn't

my %states = (
'top' => sub 
{
  html "Yahoo! Stock Quotes",
       "<form>
        Enter stock symbol: <input type=text name=symbol maxlength=20>
        <input type=hidden name=state value=getstock>
        <input type=submit value='!OK' bind=SK1>
        </form>".
        #<form>
        #<input type=submit bind=sk2 value='DowJones'>
        #<input type=hidden name=symbol value='DJI&3a;^DJI'>
        #<input type=hidden name=state value=getstock>
        #</form>
        "<form>
        <input type=submit bind=sk3 value='Nasdaq'>
        <input type=hidden name=symbol value='^IXIC'>
        <input type=hidden name=state value=getstock>
        </form>
        <form>
        <input type=submit bind=sk4 value='S&P500'>
        <input type=hidden name=symbol value='^GSPC'>
        <input type=hidden name=state value=getstock>
        </form>";
},

'getstock' => sub
{
  (my $symbol = CGI::param 'symbol') =~ s/[^^A-Za-z.=]//g;
  $symbol or die "you must enter a valid stock symbol\n";
  my $q = Finance::Quote->new;
  $q->require_labels(qw/last net p_change volume day_range year_range/);
  my %qt = $q->fetch("usa",$symbol) or die "could not retrieve stock information, please try again later\n";
  # extract real symbol from response hash

  $symbol = (split $;, (each %qt)[0])[0];
  $qt{$symbol,"success"} or die "'$symbol' is not a valid stock symbol.\n";

  my $name = $qt{$symbol,'name'}; $name=defined($name)?'('.substr($name,0,60).')':"";  
  my $last = $qt{$symbol,'last'}; $last=$last?"Last Trade : $last\n":"";
  my $net = $qt{$symbol,'net'}; my $p_change=$qt{$symbol,'p_change'};
  $net = defined($net)?"Change     : $net".($p_change?" ($p_change\%)":"")."\n":"";
  my $volume = $qt{$symbol,'volume'}; $volume=$volume?"Volume     : $volume\n":"";
  my $day_range = $qt{$symbol,'day_range'}; $day_range=defined($day_range)?"Range      : $day_range\n":"";
  my $year_range = $qt{$symbol,'year_range'}; $year_range=defined($year_range)?"Year Range : $year_range\n":"";
     
  html "Yahoo! Stock Quotes - $symbol", "<pre>Symbol     : $symbol $name\n$last$net$volume$day_range$year_range</pre>";
},
                
);


my $state = (CGI::param 'state') || 'top'; 
exists $states{$state} and $states{$state}->(); 
die "invalid cgi state '$state'";


