// crypto routines

typedef char KEY[65]; // 65 chars is 256 bits

// comment out unused features
#define ENCRYPT
#define DECRYPT
#define KEYGEN

#ifdef ENCRYPT
// encrypt message in place, with EKEY,
void encrypt(KEY E, KEY message);
#endif

#ifdef DECRYPT
// decrypt message in place
void decrypt(KEY D, KEY E, KEY message);
#endif

#ifdef KEYGEN
// Generate public (E) and private (D) keys
// Each key should be initialized with random chars ' ' to '~',
// attempts to limit key length to specified number of bits,
// returns actual bit length of E.
int keygen(KEY D, KEY E, int bits);
#endif

