# various html routines for dbman
package dbCGI::gui;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(supplied opt html timestamp $HEAD);

use warnings;
use strict;
use CGI qw(param);

# get required http parameter 
sub supplied($)
{
  param $_[0] or die "Missing parameter '$_[0]'\n";
}  

# return html option string with default
sub opt($$;$) 
{ 
  my ($s, $selected, $value)=@_; 
  my $o = ""; $value and $o .= " value='$value'"; $selected and $o .= " selected";
  "<option$o>$s</option>";  
}

# given time and params in order year, month, day, hour, minute, second (or undef for any) 
# return list of params but if any undefined the return specified time instead
# whence 0 = today at midnight, 1=today at 11:59:59PM, 2=80 days ago midnight, 3 = now
sub timestamp($;@)
{
  my $whence = shift;
  my @time;
  if ($whence==0) {@time=((localtime)[5,4,3],0,0,0)}
  elsif ($whence==1) {@time=((localtime)[5,4,3],23,59,59)}
  elsif ($whence==2) {@time=((localtime time-(86400*80))[5,4,3],0,0,0)}
  else { @time = (localtime)[5,4,3,2,1,0] }
  $time[0] += 1900;  # fix year
  $time[1] +=1;      # fix month
  @_ or return @time;
  my @a;
  for (@_)
  {
    defined $_ or push(@a,undef), next;
    my $p = param $_;
    defined $p or return @time;
    push @a, $p;
  }
  return @a;
}
 
# enclose text in appropriate html, using specified head, and exit
our $HEAD = "<meta http-equiv=pragma content=no-cache> 
             <meta http-equiv=cache-control content=no-cache>
             <meta http-equiv='expires' content='-1'>";

sub html(@)
{
  $::CLIENT_ID and unshift @_,"<b>\u$::CLIENT</b><hr>";

  local $" = ""; 
  print "Content-type: text/html\n\n
         <html>
           <head>
             $HEAD
             <title>Databug Manager</title>
             <style type='text/css'> form{margin:0} pre{margin:0} table{margin:0}
                                     body{background-color:white; font-family:'Tahoma', sans-serif; color:black}
                                     td.data {font-family:'Courier New', monospace} 

             </style>
           </head> 
           <body> @_ </body>
           </html>\n";
  exit;
}

1; 
