#!/usr/bin/perl 
use warnings;
use strict;
use DBI;

# this cgi checks for databug session activity, return 200 if ok or 410 if an error

sub error($) { print "Status: 410 @_\nContent-type: text/plain\n\nERROR: @_"; exit; }

# note, connect to backup database!
my $db = DBI->connect('DBI:mysql:databug:dbdbro','databug',undef,{RaiseError => 0, AutoCommit=>1});
END { $db and $db->disconnect() }

$db or error "DB CONNECT ERROR";

# check time on last record
my @r = $db->selectrow_array("select unix_timestamp(now()), unix_timestamp(time) from databug.xml order by id desc limit 1");

# check various 800 nums 
my @s = $db->selectrow_array("select unix_timestamp(now()), unix_timestamp(time)+duration-1 from databug.session 
                                where phone like '%8003032107%' order by id desc limit 1");
                                
#my @t = $db->selectrow_array("select unix_timestamp(now()), unix_timestamp(time)+duration-1 from databug.session 
#                                where phone like '%8006451588%' order by id desc limit 1");

# @r && @s && @t or error "DB QUERY ERROR";
@r && @s or error "DB QUERY ERROR";

my $r = ($r[0] >= $r[1]) ? $r[0]-$r[1] : -1;
my $s = ($s[0] >= $s[1]) ? $s[0]-$s[1] : -1;
#my $t = ($t[0] >= $t[1]) ? $t[0]-$t[1] : -1;

#($r > 10*60) || ($s > 60*60) || ($t > 60*60) and error "LAST XML=$r, 8003032107=$s, 8006451588=$t SECS AGO";
($r > 3600*2) || ($s > 3600*6) and error "LAST XML=$r, 8003032107=$s SECS AGO";

# bye!
print <<EOT;
Status: 200 OK
Content-type: text/html

<html>
<head>
<meta http-equiv='refresh' content='5'>
<title>Databug Watchdog</title>
</head>
<body>
Last Databug record is <b>$r</b> seconds old.<br>
Last call to 800-303-2107 ended <b>$s</b> seconds ago.<br>
</body>
</html>
EOT
  
#Last call to 800-645-1588 ended <b>$t</b> seconds ago.<br>
