#!/usr/bin/perl

use CGI;
use URI;
use LWP::Simple;
use warnings;
use strict;
use DBI;

# get html param or die
sub need($)
{
  my $r = CGI::param($_[0]) or die "missing param '$_[0]'\n";
  $r;
} 

# return html to bind button to left or right sidekey
sub left($$) 
{ 
  my ($n,$v) = @_; 
  "&lt;--<input type=submit name='$n' value='$v' bind=left>"." "x(37-length $v); 
} 

sub right($$) 
{ 
  my ($n,$v) = @_; 
  " "x(36-length $v)."<input type=submit name='$n' value='$v' bind=right>--&gt;<br>"; 
} 

# output html page
sub html($@)
{
  my $title = shift;
  my $html = join '',@_;

  print "Content-type: text/html\n\n<html>
         <head><title>$title</title>
         </head>
         <body>
         $html  
         </body></html>";
  exit;
}

$SIG{__DIE__}= sub { chomp(my @s = @_); html "Sorry","An error has occurred: @s." };
$SIG{__WARN__}=sub { warn "@{[scalar localtime]}:$ENV{QUERY_STRING}]:@_" }; # add timestamp because apache doesn't

my %states = (
top => sub 
{
  # careful, don't blow the whitespace
  html "Horoscope -- What's Your Sign?",
       "<form><input type=hidden name=state value='show'>",
       "<pre>",left('sign','Aries'),right('sign','Libra'),
               left('sign','Taurus'),right('sign','Scorpio'),
               left('sign','Gemini'),right('sign','Sagittarius'),
               left('sign','Cancer'),right('sign','Capricorn'),
               left('sign','Leo'),right('sign','Aquarius'),
               left('sign','Virgo'),right('sign','Pisces'),
       "</pre></form>";
},

show => sub 
{
  my $sign = need 'sign';
  
  my $DB = DBI->connect('DBI:mysql:news:db','news',undef,{RaiseError => 1, AutoCommit=>1}) or die "can't connect to database\n";
  
  my $r = $DB->selectrow_arrayref('select date, scope from horoscope where sign=?',undef,$sign) or die "invalid sign '$sign'\n";

  html "$sign -- $r->[0]", $r->[1];
}
                
);


my $state = (CGI::param 'state') || 'top'; 
exists $states{$state} and $states{$state}->(); 
die "invalid cgi state '$state'";


