#!/usr/bin/perl 

use warnings;
use strict;
use CGI;
use DBI;

# output text as html 
sub html(@)
{
  print "Content-type: text/html

         <html>
         <head>
           <title>Popper Errors</title>
           <meta http-equiv=pragma content=no-cache> 
           <meta http-equiv=cache-control content=no-cache>
           <meta http-equiv='expires' content='-1'>
           <style type='text/css'> 
	      form {margin:0} pre{margin:0} table{margin:0}
              body {background-color:white; font-family:'Tahoma', sans-serif; color:black; font-size:16pt}
              table {font-family:'Tahoma', sans-serif; color:black; font-size:12pt}
              tr.fail { background-color: red; color:white}
              tr.failing { background-color: yellow }
              </style>
         </head><body>
         <b>Popper Errors</b><hr>
         @_</body></html>";
  exit;
}

# mysql> desc mailbug.mailbox;
# +----------+-------------+------+-----+---------------------+----------------+
# | Field    | Type        | Null | Key | Default             | Extra          |
# +----------+-------------+------+-----+---------------------+----------------+
# | id       | bigint(20)  |      | PRI | NULL                | auto_increment |
# | hostname | varchar(64) |      |     |                     |                |
# | username | varchar(64) |      | MUL |                     |                |
# | password | varchar(64) |      |     |                     |                |
# | lastread | datetime    |      |     | 0000-00-00 00:00:00 |                |
# | new      | tinyint(1)  |      |     | 0                   |                |
# | poperrs  | int(11)     |      |     | 0                   |                |
# | poplast  | tinytext    |      |     |                     |                |
# +----------+-------------+------+-----+---------------------+----------------+
# 8 rows in set (0.00 sec)

my $DB = DBI->connect('DBI:mysql:mailbug:mbdb','mailbug',undef,{RaiseError => 1, AutoCommit=>1}) or die "can't connect to database\n";

my $errs = $DB->selectall_arrayref('select username, hostname, lastread, poperrs, poplast from mailbox where poperrs > 0 order by lastread desc');

html "<table border=1>",
     "<tr><th>Username<th>Server<th>Last Accessed<th>#Errs<th>Last Error", 
     map("<tr ".($_->[3]==12?"class=fail":$_->[3]>=4?"class=failing":"").">".join('', map "<td>$_", @$_), @$errs),
     "</table
     <p>
     <table border=1><tr><td>Legend:
                     <tr class=failing><td>Mailbug must reauthenticate.
                     <tr class=fail><td>Popper will no longer poll until Mailbug re-authenticates.
     </table>";                
